<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>userDetail</title>
    <!-- Nhúng thư viện bootstrap -->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
    <div class="container jumbotron w-50">
        <div class="row form-group">
            <div class="col-sm-12 text-center">
                <h3>Chi Tiết User</h3>
                <a id="input-id"></a>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-3">
                <label>Name:</label>
            </div>
            <div class="col-sm-9">
                <input id="inp-name" class="form-control">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-3">
                <label>Username:</label>
            </div>
            <div class="col-sm-9">
                <input id="inp-username" class="form-control">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-3"><label>Email:</label></div>
            <div class="col-sm-9"><input id="inp-email" class="form-control"></div>
        </div>
        <div class="row form-group">
            <div class="col-sm-3">
                <label>Address:</label>
            </div>
            <div class="col-sm-9">
                <div class="row form-group">
                    <div class="col-sm-2">
                        <label for="suite">Suite:</label>
                    </div>
                    <div for="input-suite" class="col-sm-10">
                        <input type="text" id="inp-suite" class="form-control">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-2">
                        <label for="street">Street:</label>
                    </div>
                    <div for="input-street" class="col-sm-10">
                        <input type="text" id="inp-street" class="form-control">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-2">
                        <label for="city">City:</label>
                    </div>
                    <div for="input-city" class="col-sm-10">
                        <input type="text" id="inp-city" class="form-control">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-2">
                        <label for="zipcode">Zip code:</label>
                    </div>
                    <div for="input-zipcode" class="col-sm-10">
                        <input type="text" id="inp-zipcode" class="form-control">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-2">
                        <label for="geo">Geo:</label>
                    </div>
                    <div class="col-sm-10">
                        <div class="row form-group">
                            <div class="col-sm-2">
                                <label for="lat"> Lat:</label>
                            </div>
                            <div class="col-sm-10">
                                <input type="text" id="inp-lat" class="form-control">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-2">
                                <label for="lng"> lng:</label>
                            </div>
                            <div class="col-sm-10">
                                <input type="text" id="inp-lng" class="form-control">
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-3">
                <label>Phone:</label>
            </div>
            <div class="col-sm-9">
                <input class="form-control" id="inp-phone" type="text">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-3">
                <label>Website:</label>
            </div>
            <div class="col-sm-9">
                <input class="form-control" id="inp-website" type="text">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-3">
                <label>Company:</label>
            </div>
            <div class="col-sm-9">
                <div class="row form-group">
                    <div class="col-sm-3">
                        <label for="companyName">Name:</label>
                    </div>
                    <div class="col-sm-9">
                        <input type="text" class="form-control" id="inp-company-name">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-3">
                        <label for="catchPhrase">Catch Phrase:</label>
                    </div>
                    <div class="col-sm-9">
                        <input type="text" class="form-control" id="inp-catch-phrase">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-3">
                        <label for="bs">bs:</label>
                    </div>
                    <div class="col-sm-9">
                        <input type="text" class="form-control" id="inp-bs">
                    </div>
                </div>
            </div>

        </div>
        <div class="row form-group">
            <div class="col-sm-12" style="text-align: right;">
                <button id="btn-update" class="btn btn-success w-25">Update</button>
                <button id="btn-back" class="btn btn-danger w-25">Cancel</button>
            </div>
        </div>
    </div>
</body>

<script>
     /***REGION 1***/
    var gUrlString = window.location.href;
    var gURL = new URL(gUrlString);
    var gUserId = gURL.searchParams.get("id");
    /***REGION 2***/
$(document).ready(function(){
    onPageLoading();
});

    /***REGION 3***/
function onPageLoading(){
    console.log("id truyền qua là: "+gUserId);
    $.ajax({
        url: "https://jsonplaceholder.typicode.com/users" +"/" + gUserId, //duong dan khac chus ys
        type: 'GET',
        dataType: 'json', // added data type
        success: function (res) {
          console.log(res);  //response text
          //bước 4. xử lý hiện thị 
         hienThiDuLieuUser(res);  //chính là post object
                 
        },
        error: function (ajaxContext) {
          alert(ajaxContext.responseText);
        }
      });
    $("#btn-back").on("click", function(){
    onBtnBackClick();
    });
    $("#btn-update").on("click", function(){
    onBtnUpdateClick();
    });
}
function onBtnBackClick(){
    window.location.href="Task 35.10.html";
}
    /***REGION 4***/
function hienThiDuLieuUser(paramRes){
    $("#inp-name").val(paramRes.name);
    $("#inp-username").val(paramRes.username);
    $("#inp-email").val(paramRes.email);
    $("#inp-suite").val(paramRes.address.suite);
    $("#inp-street").val(paramRes.address.street);
    $("#inp-city").val(paramRes.address.city);
    $("#inp-zipcode").val(paramRes.address.zipcode);
    $("#inp-lat").val(paramRes.address.geo.lat);
    $("#inp-lng").val(paramRes.address.geo.lng);
    $("#inp-phone").val(paramRes.phone);
    $("#inp-website").val(paramRes.website);
    $("#inp-company-name").val(paramRes.company.name);
    $("#inp-catch-phrase").val(paramRes.company.catchPhrase);
    $("#inp-bs").val(paramRes.company.bs);

}
function onBtnUpdateClick(){
    var vUserNewInfo={
        id:"",
        name:"",
        username:"",
        email:"",
        address:{street:"", suite:"", city:"", zipcode:"",geo:{lat:"", lng:""}},
        phone:"",
        website:"",
        company:{name:"",catchPhrase:"", bs:""}
    };
    getUserNewInfo(vUserNewInfo);
    var vIsOk=validateNewInfo(vUserNewInfo);
    if (vIsOk){
        callApiToUpdateUser(vUserNewInfo);
    }
}
function getUserNewInfo(paramUserNewInfo){
    paramUserNewInfo.id=gUserId;
    paramUserNewInfo.name=$("#inp-name").val();
    paramUserNewInfo.username=$("#inp-username").val();
    paramUserNewInfo.email=$("#inp-email").val();
    paramUserNewInfo.address.suite=$("#inp-suite").val();
    paramUserNewInfo.address.street=$("#inp-street").val();
    paramUserNewInfo.address.city=$("#inp-city").val();
    paramUserNewInfo.address.zipcode=$("#inp-zipcode").val();
    paramUserNewInfo.address.geo.lat=$("#inp-lat").val();
    paramUserNewInfo.address.geo.lng=$("#inp-lng").val();
    paramUserNewInfo.phone=$("#inp-phone").val();
    paramUserNewInfo.website=$("#inp-website").val();
    paramUserNewInfo.company.name= $("#inp-company-name").val();
    paramUserNewInfo.company.catchPhrase=$("#inp-catch-phrase").val();
    paramUserNewInfo.company.bs=$("#inp-bs").val();
    
    console.log(paramUserNewInfo);

}
function validateNewInfo(paramUserNewInfo){
    alert("Xem kỹ thông tin lại 10 lần trước khi cập nhật, có sai sót bạn tự chịu trách nhiệm nhé !");
    return true;
}
function callApiToUpdateUser(paramUserNewInfo){
    console.log("đang thực hiện tiến trình update");
    $.ajax({
            url: "https://jsonplaceholder.typicode.com/users/" +gUserId,
            type: "PUT",
            contentType: "application/json",
            data: JSON.stringify(paramUserNewInfo),
            success: function (resNewUsers) {
                console.log(resNewUsers);
                alert("cập nhật thành công"); 
                window.location.href="Task 35.10.html"             
            },
            error: function (ajaxContext) {
                console.log(ajaxContext.responseText);
            },
        });
}


</script>

</html>